
import math as Math 
# import copy


def getTotalAxes(xAxes,yAxes,zAxes):
    # totalAxes = np.sqrt(xAxes * xAxes + yAxes * yAxes + zAxes * zAxes)
    out = []
    for i in range(len(xAxes)):
        out.append(xAxes[i] * xAxes[i] + yAxes[i] * yAxes[i] + zAxes[i] * zAxes[i])
    totalAxes = np_sqrt(out)
    return totalAxes
    

def getRoll(Ax,Az):
    # roll = np.arctan2(-Ax,Az)*180 / np.PI
    a = np_arctan2([-1 * i for i in Ax],Az)
    roll = np_multiply(a,180,1/Math.pi)
    return roll

def getPitch(Ay,Az):
    # pitch = -(np.arctan2(-Ay,Az)*180) / np.PI
    a = np_arctan2([-1 * i for i in Ay],Az)
    pitch = np_multiply(a,180,1/Math.pi)
    return pitch

def getMean(input):
    mean = np_mean(input)
    return mean

def getMean2D(input):
    return np_mean_2d(input)
    

def getVariance(input):
    mean = getMean(input)
    variance = 0
    for i in range(len(input)):
        delta = input[i]- mean
        variance = variance + delta*delta
    variance = variance / (len(input)-1)
    return variance

def getVariance2(input):
    variance = np_var(input)
    return variance

def getVariance2D(input):
    variance = np_var_2d(input)
    return variance

def getStandardDeviation(input):
    variance = getVariance(input)
    standardDeviation = Math.sqrt(variance)
    return standardDeviation

def getStandardDeviation2(input):
    variance = getVariance2(input)
    standardDeviation = Math.sqrt(variance)
    return standardDeviation

def getStandardDeviation2D(input):
    # return np.std(input,axis = 1)
    return np_std_2d(input)

def getCovariance(input1,input2):
    mean1 = getMean(input1)
    mean2 = getMean(input2)
    cov = 0
    for i in range(len(input1)):
        cov += (input1[i] - mean1)* (input2[i] - mean2)
    return cov / (len(input1)-1)

def getCorrelation(input1,input2):
    standardDeviation1 = getStandardDeviation(input1)
    standardDeviation2 = getStandardDeviation(input2)
    cov = getCovariance(input1,input2)
    return cov / (standardDeviation1 * standardDeviation2)

def getZeroCrossingRate(input):
    zcr = 0
    for i in range(len(input)-1):
        if (input[i] * input[i+1]<0):
            zcr +=1
    zcr = zcr / (len(input))
    return zcr

def getZeroCrossingRate2D(input):
    col = len(input)
    # print("col",col)
    # output = np.zeros((col))
    output = [0 for i in range(col)]
    for i in range(col):
        output[i] = getZeroCrossingRate(input[i])
    return output

def getRootMeanSquare(input):
    rms = 0
    for i in range(len(input)):
        rms += Math.pow(input[i],2)
    return Math.pow(rms/len(input),0.5)

def getRootMeanSquare2D(input):
    col = len(input)
    # output = np.zeros((col))
    output = [0 for i in range(col)]
    for i in range(col):
        output[i] = getRootMeanSquare(input[i])
    return output

def getSkewness (input):
    skew = 0
    mean = getMean(input)
    std = getStandardDeviation2(input)
    for i in range(len(input)):
        skew += Math.pow(input[i]-mean,3)
    skew = skew / (len(input)*Math.pow(std,3))
    return skew


def getSkewness2D (input):
    col = len(input)
    # output = np.zeros((col))
    output = [0 for i in range(col)]
    for i in range(col):
        output[i] = getSkewness(input[i])
    return output


def getKurtosis(input):
    kurt = 0
    mean = getMean(input)
    std = getStandardDeviation2(input)
    for i in range(len(input)):
        kurt = kurt + Math.pow(input[i]-mean,4)
    kurt = kurt / (len(input) * Math.pow(std,4))
    return kurt

def getKurtosis2D(input):
    col = len(input)
    # output = np.zeros((col))
    output = [0 for i in range(col)]
    for i in range(col):
        output[i] = getKurtosis(input[i])
    return output

def getMeanAbsDev(input):
    mad = 0 
    mean = getMean(input)
    for i in range(len(input)):
        mad += abs(input[i]-mean)
    return mad/len(input)

def getMeanAbsDev2D(input):
    col = len(input)

    output = [0 for i in range(col)]
    for i in range(col):
        output[i] = getMeanAbsDev(input[i])
    return output


    




    
def np_sqrt(x):
    out = []
    for i in x:
        out.append(Math.sqrt(i))
    return out

def np_mean(x):
    return sum(x)/len(x)

def mean(x):
    return sum(x)/len(x)

def np_arctan2(x,y):
    out = []
    for i in range (len(x)):
        out.append(Math.atan2(x[i],y[i]))
    return out

def np_mean_2d(x):
    out= []
    for i in range(len(x)):
        out.append(np_mean(x[i]))
    return out

def np_multiply(x,par,par2):
   out = [par*i for i in x]
   out2 = [par2*i for i in out]
   return out2 

def np_var(x):
    out =[]
    mean_v = mean(x)
    for i in x:
        out.append((abs(i - mean_v)**2))
    return np_mean(out)

def np_var_2d(x):
    out = []
    for i in range (len(x)):
        out.append(np_var(x[i]))
    return out


def np_std(x):
    out =[]
    mean_v = mean(x)
    for i in x:
        out.append((abs(i - mean_v)**2))
    out = Math.sqrt(np_mean(out))
    return out
    
def np_std_2d(x):
    out = []
    for i in range (len(x)):
        out.append(np_std(x[i]))
    return out



def tree(x):
    if x[75] <= 289.08203125:
        if x[23] <= 166975.9765625:
            return [[0.0, 0.0, 0.0, 0.0, 87.0]]
        else:  # if x[23] > 166975.9765625
            print(x[7])
            if x[7] <= 290.35804748535156:
                return [[0.0, 0.0, 0.0, 1.0, 0.0]]
            else:  # if x[7] > 348.35804748535156
                return [[168.0, 0.0, 0.0, 0.0, 0.0]]
    else:  # if x[75] > 289.08203125
        if x[3] <= 357.4832763671875:
            if x[70] <= 0.1411853041499853:
                return [[0.0, 0.0, 0.0, 0.0, 1.0]]
            else:  # if x[70] > 0.1411853041499853
                return [[0.0, 133.0, 0.0, 0.0, 0.0]]
        else:  # if x[3] > 357.4832763671875
            if x[14] <= -19.411468505859375:
                return [[0.0, 0.0, 85.0, 0.0, 0.0]]
            else:  # if x[14] > -19.411468505859375
                return [[0.0, 0.0, 0.0, 92.0, 0.0]]




def feature_ex(x):
    t = []
    indexAx = 0
    indexAy = 1
    indexAz = 2
    indexGx = 3
    indexGy = 4
    indexGz = 5
    indexTotalAcc = 6
    indexTotalGyro = 7
    indexRoll = 8
    indexPitch = 9
    
    totalAcc = getTotalAxes(x[indexAx],x[indexAy],x[indexAz])
    totalGyro = getTotalAxes(x[indexGx],x[indexGy],x[indexGz])
    roll = getRoll(x[indexAx],x[indexAz])
    pitch = getPitch(x[indexAy],x[indexAz])

    processedKoalaData = [[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0] for i in range(10)]

    for i in range(6):
        processedKoalaData[i] = (x[i])
    processedKoalaData[6] = (totalAcc)
    processedKoalaData[7] = (totalGyro)
    processedKoalaData[8] = (roll)
    processedKoalaData[9] = (pitch)


    standardDeviation = getStandardDeviation2D(processedKoalaData)
    mean = getMean2D(processedKoalaData)
    variance = getVariance2D(processedKoalaData)
    zeroCrossingRate = getZeroCrossingRate2D(processedKoalaData)
    rootMeanSquare = getRootMeanSquare2D(processedKoalaData)
    skewness = getSkewness2D(processedKoalaData)
    kurtosis = getKurtosis2D(processedKoalaData)
    meanAbsDev = getMeanAbsDev2D(processedKoalaData)

    t.append(standardDeviation)
    t.append(mean)
    t.append(variance)
    t.append(zeroCrossingRate)
    t.append(rootMeanSquare)
    t.append(skewness)
    t.append(kurtosis)
    t.append(meanAbsDev)

    return t


def argmax(lst):
    index = 0
    print("lst",lst)
    for i in range(1,len(lst[0])):
        if (lst[0][i]>lst[0][i-1]):
            index = i
    return index


# import numpy as np
def getResult(ax,ay,az,gx,gy,gz):
    sensor = []
    sensor.append(ax)
    sensor.append(ay)
    sensor.append(az)
    sensor.append(gx)
    sensor.append(gy)
    sensor.append(gz)
    sensor = feature_ex(sensor)
    # sensor = np.array(sensor)
    # print (sensor.shape)
    print("sensor ", sensor)
    sensor_new = []
    for i in range(len(sensor)):
        sensor_new.extend(sensor[i])
    # sensor = np.reshape(sensor,(1,sensor.shape[0]*sensor.shape[1]))
    # print (sensor.shape)
    print (len(sensor_new))
    train_X_predicted = argmax(tree(sensor_new))
    # print (train_X_predicted)
    return train_X_predicted


def Main_loop(ax,ay,az,gx,gy,gz):
    # ax = [19, 28, 29, 17, 25, 18, 13, 22, 21, 26, 14, 23, 11, 10, 12, 16, 15, 20, 24, 27]
    # ay = [20, 28, 10, 14, 21, 19, 17, 13, 29, 23, 27, 26, 16, 22, 11, 15, 25, 24, 18, 12]
    # az = [12, 14, 11, 26, 21, 22, 13, 23, 18, 10, 19, 16, 20, 27, 17, 28, 15, 25, 29, 24]
    # gx = [22, 11, 23, 15, 25, 12, 10, 19, 14, 20, 13, 17, 16, 24, 26, 27, 29, 28, 18, 21]
    # gy = [23, 21, 19, 17, 24, 29, 26, 27, 12, 15, 10, 22, 16, 13, 28, 25, 11, 20, 18, 14]
    # gz = [22, 23, 18, 21, 25, 29, 28, 13, 26, 20, 19, 10, 27, 17, 12, 24, 16, 15, 14, 11]
    print(ax)

    t = getResult(ax,ay,az,gx,gy,gz)
    return (t)